program Tricks32;
uses WinTypes, WinProcs;

var	Gotname : Boolean;
	P1,Helpfile,Exefile : array[0..127] of Char;
	ExeResult: integer;
	rec : TOfStruct;
{$R trick32.res}

function ExtractFileName(const FileName: string): string;
var
  I: Integer;                       
begin
  I := Length(FileName);
  while (I > 0) and not (FileName[I] in ['\', ':']) do Dec(I);
  Result := Copy(FileName, I + 1, 255);
end;
{$H+}
function StrLCopy(Dest, Source: PChar; MaxLen: Cardinal): PChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     EBX,ECX
        XOR     AL,AL
        TEST    ECX,ECX
        JZ      @@1
        REPNE   SCASB
		JNE     @@1
        INC     ECX
@@1:    SUB     EBX,ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,EDI
        MOV     ECX,EBX
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EBX
        AND     ECX,3
        REP     MOVSB
        STOSB
        MOV     EAX,EDX
        POP     EBX
        POP     ESI
        POP     EDI
end;

function StrPCopy(Dest: PChar; const Source: string): PChar;
begin
  Result := StrLCopy(Dest, PChar(Source), 255);
end;

function StrPas(Str: PChar): string;
begin
  Result := Str;
end;

function ChangeFileExt(const FileName, Extension: string): string;
var
  I: Integer;
begin
  I := Length(FileName);
  while (I > 0) and not (FileName[I] in ['.', '\', ':']) do Dec(I);
  if (I = 0) or (FileName[I] <> '.') then I := MaxInt;
  Result := Copy(FileName, 1, I - 1) + Extension;
end;



begin
	ExeResult := 0;
	Gotname := False;

{Fetch .EXE filename}
	GetModuleFileName(GetModuleHandle('TRICKSTR'), Exefile, SizeOf(ExeFile)+1);
	StrPCopy(ExeFile,ExtractFilename(ExeFile));
	StrPCopy(Helpfile,ChangeFileExt(StrPas(ExeFile),'.HLP'));
{Get helpfile...}
	 If OpenFile(Helpfile, rec, OF_EXIST) <> HFILE_ERROR Then begin
{...and execute winhelp}
		Gotname := True;
		StrPCopy(P1, 'winhlp32.exe ' + ChangeFileExt(StrPas(ExeFile),'.HLP'));
		ExeResult := WinExec(P1,SW_SHOWNORMAL);
		end;
{Report error if file not found or executable}
	If (ExeResult < 32) or (Gotname = false) Then begin
		StrPCopy(P1,'Unexpected launcher error.'+#10+'The ' +StrPas(Helpfile)+
			' file may be corrupt, missing or located on an inaccessible drive or partition.');
		Messagebox(0,P1,'Unable to launch',16);
		end;
end.

