unit Sampmenu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, lrsbmp16,StrRes,Rzlabel, StdCtrls, ExtCtrls, Balloon;

type
  TMainmenu = class(TForm)
	Bevel1: TBevel;
	GroupBox2: TGroupBox;
	WHMB1: TButton;
	LrsBmp1: TLrsBmp;
	LrsBmp2: TLrsBmp;
	RzLabel1: TRzLabel;
	Label1: TLabel;
	Label2: TLabel;
	Quitbutton: TButton;
	BalloonHint1: TBalloonHint;
	Button1: TButton;
	Iconhack: TButton;
    Label3: TLabel;
	Unload: TButton;
	procedure QuitbuttonClick(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure WHMB1Click(Sender: TObject);
	procedure Button1Click(Sender: TObject);
	procedure IconhackClick(Sender: TObject);
	procedure UnloadClick(Sender: TObject);
  private
	{ Private declarations }
	procedure AppInit;
  public
	{ Public declarations }
  end;

Var
	Mainmenu: TMainmenu;
	INIFile,Retstring: array [0..255] of Char;
	Section: array [0..25] of Char;

implementation

{$R *.DFM}

uses MBCode,MBEncode,Iconsorc,Iconwarn,Broomer;

procedure TMainmenu.FormCreate(Sender: TObject);
var P1: array [0..99] of Char;
begin
	Font.Name := 'MS Sans Serif';
	AppInit;
	If hPrevinst <> 0 then Application.Terminate;
end;

procedure TMainmenu.AppInit;
var	Ret2: array [0..10] of Char;
begin
	StrPCopy(INIFile, ChangeFileExt(Application.ExeName,'.INI'));
	StrPCopy(Section, 'Defaults');
End;

procedure TMainmenu.QuitbuttonClick(Sender: TObject);
begin
	Close;
end;


procedure TMainmenu.WHMB1Click(Sender: TObject);
var box : TWHMB;
begin
		box := TWHMB.Create(Application);
		Mainmenu.Hide;
		box.Showmodal;
		Mainmenu.Show;
		box.Free;
end;


procedure TMainmenu.Button1Click(Sender: TObject);
var box : TMBEnhanced;
	i1 : integer;
	Warnstring: array [0..5] of Char;
begin
	box := TMBEnhanced.Create(Application);
	Mainmenu.Hide;
	box.Showmodal;
	Mainmenu.Show;
	box.Free;
end;

procedure TMainmenu.IconhackClick(Sender: TObject);
var P1,P2: array [byte] of Char;
	box1: TIconWarningDlg;
	box2 : TIconedit;
begin
	StrPCopy(P1,ChangeFileExt(Application.ExeName,'.INI'));
	GetPrivateProfileString('Defaults','Hackwarning','',P2,SizeOf(P2),P1);
	If StrPas(P2) = StrPas('Shown') then begin
		box2 := TIconedit.Create(Application);
		Mainmenu.Hide;
		box2.ShowModal;
		Mainmenu.Show;
		box2.Free;
	end else begin
		box1 := TIconWarningDlg.Create(Application);
		Mainmenu.Hide;
		Box1.Showmodal;
		Mainmenu.Show;
		Box1.Free;
	end;
end;

procedure TMainmenu.UnloadClick(Sender: TObject);
var box : TBroom1;
begin
		box := TBroom1.Create(Application);
		Mainmenu.Hide;
		box.Showmodal;
		Mainmenu.Show;
		box.Free;
end;

end.
